#include <unistd.h>
#include <iostream>
#include "error.h"
#include "log.hh"


Logger logout(std::cout);
Logger logerr(std::cerr);

Logger::Logger(std::ostream &o, const string &file) : flux_(o) {
  this->file(file);
}

Logger::~Logger() {
  if (logfile_ != 0)
    logfile_.close();
}

bool Logger::file(const string &filename) {
  // close previous logfile
  if (logfile_.is_open())
    logfile_.close();

  // open
  logfile_.open(filename.c_str(), std::fstream::app);
  return logfile_.is_open();
}

bool Logger::has_file() const {
  return logfile_.is_open();
}

Logger &operator<<(Logger &l, const string &s) {
  l.flux_ << s;
  if (l.has_file()) {
    l.logfile_ << s;
    l.logfile_.flush();
  }
  return l;
}

Logger &operator<<(Logger &l, const char *s) {
  l.flux_ << s;
  if (l.has_file()) {
    l.logfile_ << s;
    l.logfile_.flush();
  }
  return l;
}

Logger &operator<<(Logger &l, int i) {
  l.flux_ << i;
  if (l.has_file()) {
    l.logfile_ << i;
    l.logfile_.flush();
  }
  return l;
}
